clear all
close all
clc

% Initial data ---------------------
a = 0.1;   % Length along x-axis
b = 0.2;   % Height along y-axis
N = 10;
M = 12;
T1 = 10;   % Degree
T2 = 10;
T3 = 10;
T4 = 10;

N_iter = 20;
% ----------------------------------

% Pre-processing block -------------
dx = a/(N-1);
dy = b/(M-1);

t_old = zeros(M,N);
t_new = zeros(M,N);

t_old(1,:) = T4;
t_old(M-1,:) = T2;

t_old(:,1) = T1;
t_old(:,N-1) = T3;

t_old(1,1) = (T1 + T4) / 2;
t_old(1,N-1) = (T3 + T4) / 2;

t_old(M-1,1) = (T1 + T2) / 2;
t_old(M-1,N-1) = (T2 + T3) / 2;

t_new(1,:) = T4;
t_new(M-1,:) = T2;

t_new(:,1) = T1;
t_new(:,N-1) = T3;

t_new(1,1) = (T1 + T4) / 2;
t_new(1,N-1) = (T3 + T4) / 2;

t_new(M-1,1) = (T1 + T2) / 2;
t_new(M-1,N-1) = (T2 + T3) / 2;
% ----------------------------------

% Geometry -------------------------
for n=1:N
    x(n) = dx * (n-1);
end  

for m=1:M
    y(m) = dy * (m-1);
end  
% ----------------------------------

% Calculation of temperatures ------
mesh(x,y,t_old)
%contour(x,y,t_old)
xlabel('x')
ylabel('y')
title('iteration 0')
pause(1)

for iter = 1: N_iter

for n=2:N-2
    for m=2:M-2
        t_new(m,n) = (t_old(m,n-1) + ...
                      t_old(m,n+1) + ...
                      t_old(m-1,n) + ...
                      t_old(m+1,n))/4;

    end
end   

mesh(x,y,t_new)
%contour(x,y,t_new)
xlabel('x')
ylabel('y')
title(['iteration ' int2str(iter)])
pause(1)

t_old = t_new;

end
% ----------------------------------

